image: $SKA_K8S_TOOLS_DOCKER_BUILDER_IMAGE

default:
  tags:
    - k8srunner

variables:
  GIT_SUBMODULE_STRATEGY: recursive
  PIP_CACHE_DIR: "$CI_PROJECT_DIR/.cache/pip"
  CI_POETRY_VERSION: 1.8.2

# Enable caching for python
cache:
  key: $CI_COMMIT_REF_SLUG
  paths:
    - .cache/pip

stages:
  - lint
  - build
  - test
  - publish
  - pages
  - scan

# Include CI templates
include:
    # Python
  - project: 'ska-telescope/templates-repository'
    file: 'gitlab-ci/includes/python.gitlab-ci.yml'

    # Docs pages
  - project: 'ska-telescope/templates-repository'
    file: 'gitlab-ci/includes/docs-pages.gitlab-ci.yml'

    # Tag Based GitLab Release Management
  - project: 'ska-telescope/templates-repository'
    file: 'gitlab-ci/includes/release.gitlab-ci.yml'

    # Build and push the docker image
  - project: 'ska-telescope/templates-repository'
    file: 'gitlab-ci/includes/oci-image.gitlab-ci.yml'

    # .post step finalisers eg: badges
  - project: 'ska-telescope/templates-repository'
    file: 'gitlab-ci/includes/finaliser.gitlab-ci.yml'

python-test:
  services:
    # Keep in sync with docker/test-services.docker-compose.yml
    - name: quay.io/coreos/etcd:v3.5.9
      alias: etcd
      command:
        - /usr/local/bin/etcd
        - "--advertise-client-urls=http://0.0.0.0:2379"
        - "--listen-client-urls=http://0.0.0.0:2379"
        - "--initial-advertise-peer-urls=http://0.0.0.0:2380"
        - "--listen-peer-urls=http://0.0.0.0:2380"
        - "--initial-cluster=default=http://0.0.0.0:2380"